package org.infinispan.transaction.lookup;


import org.infinispan.transaction.tm.DummyTransactionManager;

import javax.transaction.TransactionManager;
import javax.transaction.UserTransaction;


/**
 * Returns an instance of {@link org.infinispan.transaction.tm.DummyTransactionManager}.
 *
 * @author Bela Ban Sept 5 2003
 * @since 4.0
 */
public class DummyTransactionManagerLookup implements TransactionManagerLookup {

   @Override
   public TransactionManager getTransactionManager() throws Exception {
      return DummyTransactionManager.getInstance();
   }

   public static UserTransaction getUserTransaction() {
      return DummyTransactionManager.getUserTransaction();
   }

   public static void cleanup() {
      DummyTransactionManager.destroy();
   }

   @Override
   public String toString() {
      return "DummyTransactionManagerLookup";
   }
}
